/* Initialize the application */
function initApplication(watchID) {
	appVersion = '1.5.0';

	// if (navigator.splashscreen) {
	// 	navigator.splashscreen.show();
	// }

	$(document).on('pagebeforecreate orientationchange', updateIcons);
	$(document).on("pagecontainertransition", updateIcons);
	$(document).on("pagecontainertransition", setContentHeight);
	$(window).on("resize orientationchange", setContentHeight);

	// setTimeout(function(){
	// 	if (navigator.splashscreen) {
	// 		navigator.splashscreen.hide();
	// 	}
	// }, 5000);
   
	$('#welcome-page').live(
		'pageshow',
		function() {
			activeScreen = "W";
//			setTimeout(function(){ 
//				setContentHeight();
//			}, 0);
			intADSshowadcount++;
			if (intADSshowadcount==4) {
				if (blnADSStarted==true) {
					if (typeof AdMob!="undefined") {
						AdMob.setOptions( arrADSdefaultOptions );
						AdMob.prepareInterstitial( {adId:strADSadmobid.interstitial, autoShow:false} );
					}
				}
			}
			if (intADSshowadcount>4) {
				intADSshowadcount=-5;
				if (blnADSStarted==true) {
					if (typeof AdMob!="undefined") {
						$('#payoff').html('powered by My Brain');
						if (blnADSinterstitialIsReady==true) {
							AdMob.showInterstitial();
						}
					} else {
						$('#payoff').html('powered by MY BRAIN');
					}
				}
			}
/*			setTimeout(function(){ 
				if (blnADSStarted==true) {
					if (typeof AdMob!="undefined") {
						AdMob.setOptions( arrADSdefaultOptions );
						AdMob.createBanner( {adId: strADSadmobid.banner, position: AdMob.AD_POSITION.BOTTOM_CENTER, autoShow: false} );
					}
				}
			}, 0);
			setTimeout(function(){ 
				if ((blnAppStarted==false) && (navigator.splashscreen)) {
					blnAppStarted = true;
					navigator.splashscreen.hide();
				}
			}, 0);*/
		}
	);

	$('#addem-page').live(
		'pageshow',
		function() {
			activeScreen = "2";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				$.mobile.loading('hide');
				window.requestAnimationFrame(function () {
					addemgame = new GameManager(4, KeyboardInputManager, HTMLActuator, LocalStorageManager);
				});
			}, 0);
		}
	);
	$('#addem-page').live(
		'pagehide',
		function() {
			addemgame = null;
		}
	);

	$('#shootem-page').live(
		'pageshow',
		function() {
			activeScreen = "G";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				$.mobile.loading('hide');
				$('#current_score_num').html('0');
				$('#best_score_num').html('0');
				ShootemEngine.initialize();
				Shootemspel.initialize("shootemcanvas",sprites,startShootemspel);
			}, 0);
		}
	);
	$('#shootem-page').live(
		'pagehide',
		function() {
			// ShootemEngine = null;
			Shootemspel.endGame();
		}
	);

	$('#packem-page').live(
		'pageshow',
		function() {
			activeScreen = "P";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				$.mobile.loading('hide');
				$('#current_score_num').html('0');
				$('#best_score_num').html('0');
				window.setTimeout(function () {
					var el = document.getElementById("packem");
					PACMAN.init(el, "./packem/"); 
				}, 0);
			}, 0);
		}
	);
	$('#packem-page').live(
		'pagehide',
		function() {
			// PACMAN.setState(PAUSE);
		}
	);

	$('#matchem-page').live(
		'pageshow',
		function() {
			activeScreen = "M";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				load_matchem();
			}, 0);
		}
	);
	$('#munchem-page').live(
		'pageshow',
		function() {
			activeScreen = "S";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				app.initialize();
				setTimeout(function(){ 
					app.receivedEvent('deviceready');
				}, 0);
			}, 0);
		}
	);
	$('#munchem-page').live(
		'pagehide',
		function() {
            if (typeof game_loop != 'undefined') { clearInterval(game_loop); }
			if (watchID != null) {
				navigator.accelerometer.clearWatch(watchID);
				watchID = null;
			}
		}
	);
	$('#brickem-page').live(
		'pageshow',
		function() {
			activeScreen = "T";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				brickem.init();
			}, 0);
			setTimeout(function(){
				FastClick.attach(document.body);
				updateIcons();
			}, 0);
		}
	);
	$('#brickem-page').live(
		'pagehide',
		function() {
			brickem.state = 'pause';
			if (typeof brickem.fall_timeout != 'undefined') { clearTimeout(brickem.fall_timeout); }
			//brickem.stop_watch_touch();
		}
	);
	$('#breakem-page').live(
		'pageshow',
		function() {
			activeScreen = "B";
			$.mobile.loading('show');
			setTimeout(function(){ 
				setContentHeight();
			}, 0);
			setTimeout(function(){ 
				//	Create your Phaser game and inject it into the gameContainer div.
				//	We did it in a window.onload event, but you can do it anywhere (requireJS load, anonymous function, jQuery dom ready, - whatever floats your boat)
				//console.log('breakem start')
//				game = new Phaser.Game(320, 416, Phaser.AUTO, "breakemapp");
				game = new Phaser.Game(320, 416, Phaser.CANVAS, "breakemapp");
				//	Add the States your game has.
				//	You don't have to do this in the html, it could be done in your Boot state too, but for simplicity I'll keep it here.
				game.state.add('Boot', BasicGame.Boot);
				game.state.add('Preloader', BasicGame.Preloader);
				game.state.add('MainMenu', BasicGame.MainMenu);
				game.state.add('GameOver', BasicGame.GameOver);
				game.state.add('Congratulations', BasicGame.Congratulations);
				game.state.add('Game', BasicGame.Game);
				//	Now start the Boot state.
				game.state.start('Boot');

				$.mobile.loading('hide');
			}, 0);
			setTimeout(function(){
				FastClick.attach(document.body);
				updateIcons();
			}, 0);
			
		}
	);
	$('#breakem-page').live(
		'pagehide',
		function() {
			//console.log('breakem gameover')
			game.destroy();
			$('#breakemapp').html();
		}
	);
	$('#about-page').live(
		'pageshow',
		function() {
			activeScreen = "A";
//			setTimeout(function(){ 
//				setContentHeight();
//			}, 0);
			$(document).on('click', '#brickemgogo', function( e ) {
				blnbuttonbrickemshow = true;
				$('#moreinfoa').html('<i>unlocked</i>');
				$('#buttonbrickem').show();
			});
			$(document).on('click', '#mybrainlogo', function( e ) {
				if (blnADSStarted==true) {
					blnADSStarted=false;
					$('#moreinfoa').html('<i>unlocked</i>');
					if (typeof AdMob!="undefined") {
						if (blnADSBanner==true) {
							AdMob.hideBanner();
							blnADSBanner=false;
						}
					}
				} else {
					//if ($('#moreinfoa').html()!='') {
					if (typeof AdMob!="undefined") {
						$('#moreinfoa').html('');
						blnADSStarted=true;
					}
				}
			});
			setTimeout(function(){ 
				if (typeof AdMob=="undefined") {
					$('#payoff').html('powered by MY BRAIN');
				}
			}, 0);
		}
	);
	$('#about-page').live(
		'pagehide',
		function() {
			$(document).off('click', '#mybrainlogo');
		}
	);
	setTimeout(function(){ 
		if (typeof AdMob!="undefined") {
			// select the right Ad Id according to platform
			if( /(android)/i.test(navigator.userAgent) ) { // for android
				strADSadmobid = {
					banner: 'ca-app-pub-2066785061434895/5834622228',
					interstitial: 'ca-app-pub-2066785061434895/7311355420'
				};
			} else if(/(ipod|iphone|ipad)/i.test(navigator.userAgent)) { // for ios
				strADSadmobid = {
					banner: 'ca-app-pub-2066785061434895/1264821828',
					interstitial: 'ca-app-pub-2066785061434895/2741555021'
				};
			} else { // for windows phone
				strADSadmobid = {
					banner: 'ca-app-pub-2066785061434895/2601954223',
					interstitial: 'ca-app-pub-2066785061434895/4078687425'
				};
			}
			arrADSdefaultOptions = {
				bannerId: strADSadmobid.banner,
				interstitialId: strADSadmobid.interstitial,
				adSize: 'SMART_BANNER',
				// width: integer, // valid when set adSize 'CUSTOM'
				// height: integer, // valid when set adSize 'CUSTOM'
				position: AdMob.AD_POSITION.BOTTOM_CENTER,
				overlap:true,
				offsetTopBar: true, // avoid overlapped by status bar, for iOS7+
				bgColor: 'black', // color name, or '#RRGGBB'
				// x: integer,		// valid when set position to 0 / POS_XY
				// y: integer,		// valid when set position to 0 / POS_XY
				isTesting: false, // set to true, to receiving test ad for testing purpose
				autoShow: false // auto show interstitial ad when loaded, set to false if prepare/show
			};
			document.addEventListener('onAdFailLoad',function(data){
				//console.log( data.error + ',' + data.reason );
				if(data.adType == 'banner') {
					//$(".ui-page-active .ui-footer").show();
					AdMob.hideBanner();
				} else if(data.adType == 'interstitial') {
					blnADSinterstitialIsReady = false;
				}
				blnADSBanner = false;
			});
			document.addEventListener('onAdLoaded',function(data){
				if(data.adType == 'banner') {
					blnADSBanner = true;
					setTimeout(function(){ 
						AdMob.showBanner(AdMob.AD_POSITION.BOTTOM_CENTER);
						blnADSBanner = true;
					}, 0);
					setTimeout(function(){ 
						setContentHeight();
					}, 0);
				} else if(data.adType == 'interstitial') {
					blnADSinterstitialIsReady = true;
				}
			});
			document.addEventListener('onAdPresent',function(data){
				blnADSBanner = true;
			});
//			if (typeof AdMob!="undefined") {
//				AdMob.setOptions( arrADSdefaultOptions );
//				//AdMob.prepareInterstitial( {adId:strADSadmobid.interstitial, autoShow:false} );
//				AdMob.createBanner( {adId: strADSadmobid.banner, position: AdMob.AD_POSITION.BOTTOM_CENTER, autoShow: false} );
//			}
			blnADSStarted = true;
		}
	}, 4000);
	setTimeout(function(){ 
		if (blnADSStarted==true) {
			if (typeof AdMob!="undefined") {
				AdMob.setOptions( arrADSdefaultOptions );
				AdMob.createBanner( {adId: strADSadmobid.banner, position: AdMob.AD_POSITION.BOTTOM_CENTER, autoShow: false} );
			}
		}
	}, 9000);
}

function checkRequirements() {
	if (navigator.connection != null) {
		if ((navigator.connection.type === Connection.NONE) || (navigator.connection.type === Connection.UNKNOWN)) {
//			if (navigator.notification!=null) {
//				navigator.notification.alert(
//					'To use this App you must enable your internet connection',
//					function(){},
//					'Error'
//				);
//			} else {
//				alert('Error - To use this App you must enable your internet connection');
//			}
			return false;
		} else {
			return true;
		}
	} else {
		//keep going in a browser
		return true;
	}
	return false;
}

function updateIcons() {
	if ($(window).width() > 480) {
		$('a[data-icon], button[data-icon]').each( function() { $(this).removeAttr('data-iconpos'); } );
		$('#controlsup, #controlsdown, #controlsleft, #controlsright').attr('data-iconpos', 'notext');
	} else {
		$('a[data-icon], button[data-icon]').each( function() { $(this).attr('data-iconpos', 'notext'); } );
   }
}

function urlParam(name) {
	var results = new RegExp('[\\?&amp;]' + name + '=([^&amp;#]*)').exec(window.location.href);
	if (results != null && typeof results[1] !== 'undefined') {
		return results[1];
	} else {
		return null;
	}
}

/* fullscreen */
function setContentHeight() {
/*	if (blnADSBanner==true) {
		$(".ui-page-active .ui-footer").hide();
	} else {
		$(".ui-page-active .ui-footer").show();
	}*/

	var screenh = $.mobile.getScreenHeight(),
	screenw = $('.ui-page-active').innerWidth(),
	skip = false,
	header = $(".ui-page-active .ui-header").hasClass("ui-header-fixed") ? $(".ui-page-active .ui-header").outerHeight() : $(".ui-page-active .ui-header").outerHeight(),
	footer = $(".ui-page-active .ui-footer").hasClass("ui-footer-fixed") ? $(".ui-page-active .ui-footer").outerHeight() : $(".ui-page-active .ui-footer").outerHeight(),
	contentPadding = $(".ui-page-active .ui-content").outerHeight() - $(".ui-page-active .ui-content").height(),
	pagePadding = $(".ui-page-active").outerHeight() - $(".ui-page-active").height();
	if (!$(".ui-page-active .ui-footer").is(':visible')) { footer = 0; }
	if (blnADSStarted==true) {
		if (typeof AdMob!="undefined") {
			//if (blnADSBanner==true) {
				//SMART_BANNER - 32px, or if the screen height of a device is between 400 and 720, an ad height of 50 is used in both orientations; for screen heights greater than 720, a 90 ad height is used.
				footer = (screenh > 719 ? 90 : (screenh < 400 ? 32 : 50));
			//}
		}
	}
	var content = screenh - header - footer - contentPadding;
	var page = screenh - pagePadding;
	//$('#debugger').html(blnADSBanner+'');
	//$('#debugger').html(screenh+' '+header+' '+footer+' '+contentPadding+' '+content);
	//alert(screenh+' '+header+' '+footer+' '+contentPadding+' '+content+' '+$(".ui-page-active .ui-footer").is(':visible')+' '+(blnADSBanner==true));

	var ua = navigator.userAgent;
	if(ua.indexOf("ndroid")>=0){
		var androidversion=parseFloat(ua.slice(ua.indexOf("ndroid")+7)); 
		if(androidversion<=2.3) {
			skip = true;
		}
	}
	if (!skip) {
		if ((activeScreen!="W") && (activeScreen!="A")) {
			setTimeout(function(){ 
				$(".ui-page-active .ui-content").height(content);
				$(".ui-mobile").css("min-height",content+'px');
				$(".ui-page-active").css("min-height",content+'px');
				//if (blnADSBanner==true) {
				//	$(".ui-page-active").css("padding-bottom",'0px');
				//}
			}, 150);
		}
	}
	if (ua.indexOf("Windows Phone")>=0) {
		setTimeout(function(){
			var screenh = $.mobile.getScreenHeight(),
			header = $(".ui-page-active .ui-header").hasClass("ui-header-fixed") ? $(".ui-page-active .ui-header").outerHeight() : $(".ui-page-active .ui-header").outerHeight(),
			footer = $(".ui-page-active .ui-footer").hasClass("ui-footer-fixed") ? $(".ui-page-active .ui-footer").outerHeight() : $(".ui-page-active .ui-footer").outerHeight(),
			contentPadding = $(".ui-page-active .ui-content").outerHeight() - $(".ui-page-active .ui-content").height(),
			pagePadding = $(".ui-page-active").outerHeight() - $(".ui-page-active").height();
			if (!$(".ui-page-active .ui-footer").is(':visible')) { footer = 0; }
			if (blnADSStarted==true) {
				if (typeof AdMob!="undefined") {
					//if (blnADSBanner==true) {
						//SMART_BANNER - 32px, or if the screen height of a device is between 400 and 720, an ad height of 50 is used in both orientations; for screen heights greater than 720, a 90 ad height is used.
						footer = (screenh > 719 ? 90 : (screenh < 400 ? 32 : 50));
					//}
				}
			}
			var content = screenh - header - footer - contentPadding;
			var page = screenh - pagePadding;
			$(".ui-page-active .ui-content").height(content);
			$(".ui-mobile").css("min-height",content+'px');
			$(".ui-page-active").css("min-height",content+'px');
			$(".ui-page-active .ui-footer-fixed").css("position", "absolute");
			$(".ui-page-active .ui-footer-fixed").css("bottom", "0px");
			$(".ui-page-active .ui-footer-fixed").css("padding-bottom", "0px");
		}, 250);
	}

	if (activeScreen=="M") {
		var sh = $('#zone_score').height();
		var jh = (content-24)-sh-12;
		var jw = (screenw-24);
		if (jw>jh) { jw=jh; }
		$('#zone_jeu').width(jw);
		$('#zone_jeu').height(jh);
		setTimeout(function(){
			on_resize();
		}, 0);
	}

	if (activeScreen=="G") {
		setTimeout(function(){
			var sh = $('#zone_scoreg').height();
			var jh = (content-24)-sh-12;
			var jw = (screenw-24);
			if (jw>jh) { jw=jh; }
			if(jw > 280) {
				jw = 280;
			}
			$('#shootemapp').width(jw);
			$('#shootemapp').height(jh);
		}, 0);
	}

	if (activeScreen=="S") {
		var sh = $('#zone_scores').height();
		var jh = (content-24)-sh-12;
		var jw = (screenw-24);
		/* board is 24 blocks */
		var cw = parseInt(jw/24);
		jw = parseInt(jw/cw)*cw;
		jh = parseInt(jh/cw)*cw;
		$('#munchemapp').width(jw);
		$('#munchemapp').height(jh);
		var canvas = $('#munchemcanvas')[0];
		var ctx = canvas.getContext('2d');
		ctx.canvas.width  = jw;
		ctx.canvas.height = jh;
		$(document).trigger("munchem/resize");
	}
	if (activeScreen=="T") {
		var sh = $('#zone_scoret').height();
		var jh = (content-24)-sh-12;
		var jw = (screenw-24);
		if (jw>jh) { jw=jh; }
//		$('#game_col').width(jw);
//		$('#game_col').height(jh);
		if (typeof brickem.stage != 'undefined') { brickem.resize(); }
	}
	if (activeScreen=="B") {
		var sh = $('#zone_scoreb').height();
		var jh = (content-24)-sh-12;
		var jw = (screenw-24);
		$('#breakemapp').width(jw);
		$('#breakemapp').height(jh);
		var jhmin = (jh<200 ? jh : 200);
		var jhmax = (jh>1024 ? 1024 : jh);
		var jwmin = (jw<200 ? jw : 200);
		var jwmax = (jw>1024 ? 1024 : jw);
		if (game != null) {
			if (game.stage != null) {
				game.stage.scaleMode = Phaser.StageScaleMode.SHOW_ALL;
				game.stage.scale.minWidth = jwmin;
				game.stage.scale.minHeight = jhmin;
				game.stage.scale.maxWidth = jwmax;
				game.stage.scale.maxHeight = jhmax;
				game.stage.scale.pageAlignHorizontally = false;
				game.stage.scale.setScreenSize(true);
			}
		}
	}
	if (activeScreen=="2") {
		var sh = $('#zone_scorea').height() + $('#above-game').height();
		//console.log(sh);
		var jh = (content-24)-sh-42;
		var jw = (screenw-24-30);
		if (jw>jh) { jw=jh; } else { jh=jw; }
		var jwb = Math.floor(jw/4)*4;
		var jwc = Math.floor((jwb-45)/4);
		var jwf1 = parseInt(jwc/2)+4;
		var jwf2 = parseInt(jwc/2);
		var jwf3 = parseInt(jwc/2)-4;

		$('#game-container').width(jwb);
		$('#game-container').height(jwb);
//		$('.grid-cell, .tile, .tile .tile-inner').width(jwc);
//		$('.grid-cell, .tile, .tile .tile-inner').height(jwc);
//		$('.tile, .tile .tile-inner').css('line-height', jwc+'px');
		$('#addemCSS').html('');
		$('#addemCSS').append('.grid-cell, .tile, .tile .tile-inner { width: '+jwc+'px;height: '+jwc+'px;line-height: '+jwc+'px; }');
		$('#addemCSS').append('.grid-cell, .tile, .tile .tile-inner { width: '+jwc+'px;height: '+jwc+'px;line-height: '+jwc+'px; }');
		$('#addemCSS').append('.tile .tile-inner { font-size: '+jwf1+'px; }');
		$('#addemCSS').append('.tile.tile-128 .tile-inner { font-size: '+jwf2+'px; }');
		$('#addemCSS').append('.tile.tile-256 .tile-inner { font-size: '+jwf2+'px; }');
		$('#addemCSS').append('.tile.tile-512 .tile-inner { font-size: '+jwf2+'px; }');
		$('#addemCSS').append('.tile.tile-1024 .tile-inner { font-size: '+jwf3+'px; }');
		$('#addemCSS').append('.tile.tile-2048 .tile-inner { font-size: '+jwf3+'px; }');

		if (addemgame != null) {
			addemgame.actuator.boardwidth = jwb;
			addemgame.actuator.tilewidth = jwc;
		}
		var r,c,pr,pc;
		for (r=1;r<5;r++) {
			for (c=1;c<5;c++) {
				pr=(r-1)*(jwc+15);
				pc=(c-1)*(jwc+15);
				//$('.tile.tile-position-'+r+'-'+c).css('-webkit-transform', 'translate('+pr+'px, '+pc+'px)');
				//$('.tile.tile-position-'+r+'-'+c).css('-moz-transform', 'translate('+pr+'px, '+pc+'px)');
				//$('.tile.tile-position-'+r+'-'+c).css('transform', 'translate('+pr+'px, '+pc+'px)');
				$('#addemCSS').append('.tile.tile-position-'+r+'-'+c+' { -webkit-transform: translate('+pr+'px, '+pc+'px) }');
				$('#addemCSS').append('.tile.tile-position-'+r+'-'+c+' { -moz-transform: translate('+pr+'px, '+pc+'px) }');
				$('#addemCSS').append('.tile.tile-position-'+r+'-'+c+' { transform: translate('+pr+'px, '+pc+'px) }');
			}
		}
	}

	if (activeScreen=="A") {
	//	$("#moreinfo").html('('+window.outerWidth+')'+screenw+' x '+screenh+' ('+window.devicePixelRatio+')<br/>'+screenh+'/'+header+'/'+footer+'/'+pagePadding+'/'+contentPadding+'/'+page+'/'+content);
		$("#moreinfov").html('V' + appVersion+'<br/>');
		$("#moreinfos").html('('+window.outerWidth+' x '+window.outerHeight+')<br/>'+screenw+' x '+screenh+' (ratio '+window.devicePixelRatio+')<br/>');
		$("#moreinfou").html(ua+'<br/>');
		if (typeof cordova!="undefined") {
			cordova.getAppVersion().then(function (version) {
				$('#moreinfov').html('v'+ version + '<br/>');
			});
		}
		if (checkRequirements()==false) {
			$("#moreinfou").append('<i>No active Internet connection.<i><br/>');
		}
	}

}