BasicGame = {};

BasicGame.Boot = function (game) {

};

BasicGame.Boot.prototype = {

	preload: function () {

		$.mobile.loading('show');
		//	Here we load the assets required for our preloader (in this case a background and a loading bar)
		this.load.image('preloaderBackground', 'breakem/assets/images/preloader_background.jpg');
		this.load.image('preloaderBar', 'breakem/assets/images/preloader_bar.png');

	},

	create: function () {

		//	Unless you specifically know your game needs to support multi-touch I would recommend setting this to 1
		this.game.input.maxPointers = 1;

		//	Phaser will automatically pause if the browser tab the game is in loses focus. You can disable that here:
		this.game.stage.disableVisibilityChange = true;

		var screenh = $.mobile.getScreenHeight(),
		screenw = $('.ui-page-active').innerWidth(),
		header = $(".ui-page-active .ui-header").hasClass("ui-header-fixed") ? $(".ui-page-active .ui-header").outerHeight() - 1 : $(".ui-page-active .ui-header").outerHeight(),
		footer = $(".ui-page-active .ui-footer").hasClass("ui-footer-fixed") ? $(".ui-page-active .ui-footer").outerHeight() - 1 : $(".ui-page-active .ui-footer").outerHeight(),
		contentPadding = $(".ui-page-active .ui-content").outerHeight() - $(".ui-page-active .ui-content").height();
		if (!$(".ui-page-active .ui-footer").is(':visible')) { footer = 0; }
		if (blnADSStarted==true) {
			if (typeof AdMob!="undefined") {
				//if (blnADSBanner==true) {
					//SMART_BANNER - 32px, or if the screen height of a device is between 400 and 720, an ad height of 50 is used in both orientations; for screen heights greater than 720, a 90 ad height is used.
					footer = (screenh > 719 ? 90 : (screenh < 400 ? 32 : 50));
				//}
			}
		}
		var content = screenh - header - footer - contentPadding;
		var sh = $('#zone_scoreb').height();
		var jh = (content-24)-sh-12;
		var jw = (screenw-24);
		var jhmin = (jh<200 ? jh : 200);
		var jhmax = (jh>1024 ? 1024 : jh);
		var jwmin = (jw<200 ? jw : 200);
		var jwmax = (jw>1024 ? 1024 : jw);

	    if (this.game.device.desktop)
	    {
			//	If you have any desktop specific settings, they can go in here
		    this.game.stage.scaleMode = Phaser.StageScaleMode.SHOW_ALL;
		    this.game.stage.scale.minWidth = jwmin;
		    this.game.stage.scale.minHeight = jhmin;
		    this.game.stage.scale.maxWidth = jwmax;
		    this.game.stage.scale.maxHeight = jhmax;
		    this.game.stage.scale.pageAlignHorizontally = false;
		    this.game.stage.scale.setScreenSize(true);
	    }
	    else
	    {
			//	Same goes for mobile settings.
			//	In this case we're saying "scale the game, no lower than 480x260 and no higher than 1024x768"
		    this.game.stage.scaleMode = Phaser.StageScaleMode.SHOW_ALL;
		    this.game.stage.scale.minWidth = jwmin;
		    this.game.stage.scale.minHeight = jhmin;
		    this.game.stage.scale.maxWidth = jwmax;
		    this.game.stage.scale.maxHeight = jhmax;
		    this.game.stage.scale.pageAlignHorizontally = false;
		    this.game.stage.scale.setScreenSize(true);
            /*
		    this.game.stage.scaleMode = Phaser.StageScaleMode.SHOW_ALL;
		    this.game.stage.scale.minWidth = 480;
		    this.game.stage.scale.minHeight = 260;
		    this.game.stage.scale.maxWidth = 1024;
		    this.game.stage.scale.maxHeight = 768;
		    this.game.stage.scale.forceLandscape = true;
		    this.game.stage.scale.pageAlignHorizontally = true;
		    this.game.stage.scale.setScreenSize(true);
            */
	    }

		this.best_score_breakem = 0;
		var local_best_score = localStorage.getItem('best_score_breakem');
		if (local_best_score != null) {
			this.best_score_breakem = local_best_score;
		}
		$('#best_score_num').html(this.best_score_breakem);

	    //	By this point the preloader assets have loaded to the cache, we've set the game settings
	    //	So now let's start the real preloader going
		this.game.state.start('Preloader');
		setTimeout(function(){ 
			$.mobile.loading('hide');
		}, 0);

	}

};
